<template>
  <div class="container my-5 smallWidth mx-auto">
    <h1 class="h2 text-center mb-4">Connexion</h1>
    <b-form @submit="onSubmit" @reset="onReset" v-if="show">
      <b-form-group
        id="input-group-1"
        label="Your username"
        label-for="input-1"
        label-size="sm"
        label-class="text-muted mb-0"
      >
        <b-input-group>
          <template #prepend>
            <b-input-group-text ><b-icon icon="person-fill" class="text-muted"></b-icon></b-input-group-text>
          </template>
          <b-form-input
            id="input-1"
            v-model="form.username"
            required
          >
          </b-form-input>
        </b-input-group>
      </b-form-group>

      <b-form-group
        id="input-group-2"
        label="Your password"
        label-for="input-2"
        label-size="sm"
        label-class="text-muted mb-0"
      >
        <b-input-group>
          <template #prepend>
            <b-input-group-text ><b-icon icon="key-fill" class="text-muted"></b-icon></b-input-group-text>
          </template>
          <b-form-input
            id="input-2"
            v-model="form.password"
            type="password"
            required
          ></b-form-input>
        </b-input-group>
      </b-form-group>

      <b-button type="submit" variant="primary" class="rounded-0 mr-2 mt-3">Submit</b-button>
      <b-button type="reset" variant="outline-secondary" class="rounded-0 mt-3">Reset</b-button>
    </b-form>

  </div>
</template>

<script>
import { mapFields } from 'vuex-map-fields'

export default {
  data () {
    return {
      form: {
        username: '',
        password: ''
      },
      show: true
    }
  },
  computed: {
    ...mapFields([
      'users',
      'user'
    ])
  },
  methods: {
    findUser (username, password) {
      return this.users.some(user => user.username === username && user.password === password)
    },
    onSubmit (event) {
      event.preventDefault()
      fetch('https://fakestoreapi.com/users')
        .then(res => res.json())
        .then(data => {
          this.users = data
          if (!this.findUser(this.form.username, this.form.password)) {
            alert('WRONG CREDENTIALS')
          } else {
            this.user = this.users.find(user =>
              user.username === this.form.username && user.password === this.form.password
            )
            this.$router.push(this.$route.query.redirect || '/')
          }
        })
        .catch(e => console.log(e))
    },
    onReset (event) {
      event.preventDefault()
      // Reset our form values
      this.form.username = ''
      this.form.password = ''
      // Trick to reset/clear native browser form validation state
      this.show = false
      this.$nextTick(() => {
        this.show = true
      })
    }
  }
}
</script>

<style scoped>
.smallWidth {
  width: 100%;
  max-width: 400px;
}
</style>
